// PROJECT  :7SegmentPROGMEM
// PURPOSE  :Third of three examples highlighting where data can be placed
// COURSE   :ICS3U
// AUTHOR   :C. D'Arcy
// DATE     :2021 04 22
// MCU      :328P/84/85
// STATUS   :Working
// REFERENCE:http://darcy.rsgc.on.ca/ACES/TEI3M/ArduinoCode/TowardsBetterCode.html#memory
//library support required for access to data in Program Flash
#include <avr/pgmspace.h>
#define DURATION 1000
uint8_t digit = 0;
// Seven Segment Lookup Table (LUT) (request it be placed in Program Flash: PROGMEM Modifier)
const uint8_t Xgfabedc10 [10] PROGMEM = {B00111111, B00001001, B01011110, B01011011, B01101001,
                                 B01110011, B01110111, B00011001, B01111111, B01111001
                                };

void setup() {
  // declare all pins (except bit 7) of PORTD for output (digital pins 0 through 6)
  for (uint8_t i = 0; i < 7; i++)
    pinMode(i, OUTPUT);
}

void loop() {
  //interpret the specific segment map, displaying the given digit
  //requires the use of a library function with dereference operator
  uint8_t segmentMap = pgm_read_byte(&Xgfabedc10[digit]);
  for (uint8_t i = 0; i < 7; i++) {
    digitalWrite(i, bitRead(segmentMap, i));
  }
  //pause to admire
  delay(DURATION);
  //cycle through the digits
  digit = (digit + 1) % 10;
}
